
' ------------------------------------------------------------------------------
'  _____ _     _   _              _ _ _ _           _ _     
' |   __| |___| |_| |_ ___ ___   | | | | |_ ___ ___| |_|___ 
' |   __| | -_| '_|  _| . |  _|  | | | |   | -_| -_| | | -_|
' |_____|_|___|_,_|_| |___|_|    |_____|_|_|___|___|_|_|___|
'
'  080718-1 (c)2009 Elektor International Media B.V. / Chris Krohne
' ------------------------------------------------------------------------------
' ------------------------------------------------------------------------------
' Purpose
'   Elektor-Wheelie current controller
'
' Changes Log
'  - 2.0 : initial beta source code for publication
'  - 0.1 : initial source code for publication
'
' Notes
'  Nothing special, may come later...
' ------------------------------------------------------------------------------



$regfile = "attiny25.dat"

$crystal = 8000000

' fuses
' 0xFF, 0xDD, 0xE2

Const Cur25 = 27000
Const Curdead = 76500


Portb = 1
Config Portb = Input
Config Adc = Single , Prescaler = Auto
Start Adc
Config Portb.1 = Output
Config Portb.0 = Output



Dim Ad_curr As Long
Dim Buf As Long
Dim Av_curr As Long
Dim Cflag As Byte

Portb = 1
'disable vreg
Cflag = 0

'wait a little
Waitms 200

'Now give power to the chip



' enable vreg
Portb = 0


Av_curr = 0

S1:
Ad_curr = Getadc(2)

Buf = Av_curr / 75
Av_curr = Av_curr - Buf
Av_curr = Av_curr + Ad_curr

'Curr Flag
If Cflag = 0 Then
'0.8A'
If Av_curr > Cur25 Then
 Portb = 2
 Else
 Portb = 0
End If

End If




'over current, disable vreg
' 3.5A'
If Av_curr > Curdead Then
 Portb = 3
 Cflag = 1
End If



Goto S1




End